/**
   A simple interface for the
   IntList abstract data type.
*/
public interface IntList
{
   /**
      Calculate how many elements are in this IntList.

      @return the number of elements in this list
   */
   public int length();


   /**
      Determine if this IntList contains any elements.

      @return true of this IntList is empty, false otherwise
   */
   public boolean empty();


   /**
      Return, but do not remove, the first element of this IntList.

      @return the int value stored as the first element of this IntList
   */
   public int getFirst();


   /**
      Add a new element as the first element of this IntList.

      @param element the int value to insert as the first element of this IntList
   */
   public void insert(int element);


   /**
      Remove (and return) the first element of this IntList.

      @return the int value that was the first element of this IntList
   */
   public int remove();


   /**
      Create an array representation of the contents of this IntList.

      @return an integer array containing every element of this IntList
   */
   public int[] toArray();


   /**
      Create a String representation of the contents of this IntList.

      @return a String representation of this IntList
   */
   public String toString();

}//IntList
